#version 400
out vec4 FragColor;
in vec3 teNormal;
in vec2 teTexcoord;
in vec3 teTangent;
in vec3 teBitangent;
in vec3 teLightVec;
in vec3 teEyeVec;
in vec3 teHalfVec;
uniform sampler2D diffuse_texture;
uniform sampler2D normal_texture;        
uniform vec3 LightPosition;
uniform vec3 DiffuseMaterial;
uniform vec3 AmbientMaterial;
void main(){
    vec3 normal = 2.0 * texture2D (normal_texture, teTexcoord).rgb - 1.0;
    normal = normalize(normal);   
    
		float lamberFactor= max (dot (teLightVec, normal), 0.0) ;
		vec4 diffMaterial = vec4(0.0,0.0,0.0,0.0);
		vec4 diffUseLight  = vec4(0.0,0.0,0.0,0.0);
		
		vec4 specularMaterial ;
		vec4 specularLight ;
		float shininess ;
		
		vec4 ambientLight = vec4(AmbientMaterial,1.0);//(0.1,0.1,0.1);	
		
	if (lamberFactor > 0.0)
	{
		vec3 color = texture2D (diffuse_texture, teTexcoord).rgb;
		FragColor = vec4(lamberFactor * color,1.0);
	/*
		diffMaterial = vec4(DiffuseMaterial,1.0);//texture2D (diffuseTexture, gl_TexCoord[0].st);
		diffUseLight  = vec4(0.6,0.6,0.6,1.0);//gl_LightSource[0].diffuse;
		
		// In doom3, specular value comes from a texture 
		specularMaterial =  vec4(1.0)  ;
		specularLight = vec4(0.0);//gl_LightSource[0].specular;
		shininess = pow (max (dot (teHalfVec, normal), 0.0), 2.0)  ;
		 
		FragColor =	diffMaterial * diffUseLight * lamberFactor ;
		FragColor +=	specularMaterial * specularLight * shininess ;	*/			
	
	}		
	
	FragColor +=ambientLight;
			   
	 
}
