#version 400
in vec3 myVertex;
in vec3 myNormal;
in vec2 myTexCoord;  
in vec3 myTangent;
in vec3 myBitangent;   
out vec3 vPosition;
out vec3 vNormal;
out vec2 vTescoord;
out vec3 vLightVec;
out vec3 vEyeVec;
out vec3 vHalfVec;
uniform mat3 osg_NormalMatrix;
uniform mat4 osg_ProjectionMatrix;
uniform mat4 osg_ModelViewMatrix;     
uniform vec3 LightPosition;
void main(){
	vTescoord = myTexCoord;	
	vPosition = myVertex;
	vNormal = myNormal;
	
	vec3 vertexPosition = vec3(osg_ModelViewMatrix *  vec4(myVertex,1.0)).xyz;
	vec3 lightDir = normalize(LightPosition - vertexPosition);
	
  vec3 L;
  L.x = dot (lightDir, osg_NormalMatrix*myTangent);
  L.y = dot (lightDir, osg_NormalMatrix*myBitangent);             
  L.z = dot (lightDir, osg_NormalMatrix*myNormal);
	vLightVec = normalize(L);
		
	vec3 V;
  V.x = dot (vertexPosition, osg_NormalMatrix*myTangent);
  V.y = dot (vertexPosition, osg_NormalMatrix*myBitangent);
  V.z = dot (vertexPosition, osg_NormalMatrix*myNormal);
	vEyeVec = normalize(V);	
	
	vec3 halfVector = normalize(vertexPosition + lightDir);
	vec3 HV;
	HV.x = dot (halfVector, osg_NormalMatrix*myTangent);
	HV.y = dot (halfVector, osg_NormalMatrix*myBitangent);
	HV.z = dot (halfVector, osg_NormalMatrix*myNormal);	
	
	vHalfVec = HV;
		
}
